Attribute VB_Name = "GameMod"
'bitblt api
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
'image copy constants
Public Const SRCCOPY = &HCC0020 'used in direct copy
Public Const SRCAND = &H8800C6   '--used when copying transparent images
Public Const SRCPAINT = &HEE0086 '-^

Private Enum MapObject 'the map object type
 mBerry = 9             'these values are also the tags given to the objects
 mProtect = 8
 mLife = 7
 mCherry = 6
 mBeer = 5
 mGhoul = 4
 mFood = 3
 mPacMan = 2
 mWall = 1
 mSpace = 0
End Enum

Public Enum EndType 'ending type
 died = 1            'died before finishing game
 Completed = 2       'completed
End Enum

Public Type ObjPos 'object position types
 X As Integer
 Y As Integer
End Type

Public Const dirUp = 1        '\
Public Const dirDown = 2      ' |---direction constants
Public Const dirLeft = 3      ' |--^
Public Const dirRight = 4     '/

Public Const Grid = 330      '\
Public Const MapWidth = 19   ' |-- Map Size Constants
Public Const MapHeight = 19  '/

Public Const DrunkTimeLength = 7   '--timer constants
Public Const ProtectTimeLength = 7 '-^

Global InBltLoop As Boolean 'is it currently drawing the shield ?

Global GhoulPos(19 * 19 + 1) As ObjPos 'position of the ghouls
Global PacManPos As ObjPos 'position of pacman

Global NowDead As Boolean  'is he dead?

Global GhoulColour As Integer 'the colour of the last ghoul loaded

Global NextDirect(19 * 19 + 1) As Integer  'used to predict the next direction of the ghouls
Global LastDirect(19 * 19 + 1) As Integer  'used to see the last direction of the ghouls

Global PacManLoaded As Boolean 'is pacman loaded?

Global FoodCount As Integer ' the number of food on the level
Global WallCount As Integer ' the number of walls on the level
Global EatenFood As Integer ' the number of foods eaten
Global CurrLevel As Integer ' the current level

Global FinalString As String ' the encoded position of the pacman, ghouls or any other object. so it can be stored in a ListBox
Global TmpStr1 As String '\
Global TmpStr2 As String ' |-used when turing co-ordinates into one string, so they can be stored in a ListBox
Global TmpStr3 As String '/

Public Sub LoadMap(File As String) ' load the map
 Dim Lines As Integer, Char As Integer 'the current position in the file
 Dim MapObj As MapObject
 Dim LevLine As String 'the line of chars retrieved from the file
 On Error GoTo ErrHandler 'error in the map some where
 ThisDir "levels" 'goto app.path\levels\  directory
 Open File For Input As #1 'open the level file for input
  Line Input #1, LevScheme 'get the level scheme
  WallTypeNum = Int(Right(LevScheme, 1)) 'get the wall type
  LevScheme = Trim(Left(LevScheme, 1)) 'get the scheme type
  Load_Scheme Int(LevScheme) 'load the scheme
  For Lines = 1 To MapHeight 'go through then next 19  lines in the file
   Line Input #1, LevLine 'get the line of chars
    If Lines = 1 Or Lines = 19 Then LevLine = "1111111111111111111" 'make sure there are walls around the level
    For Char = 1 To MapWidth 'go through each char in the line of chars
     If Char = 1 Or Char = 19 Then 'make sure a wall is loaded at the edge
       MapObj = mWall 'set the map object to a wall
     ElseIf Char = 18 And Lines = 18 And PacManLoaded = False Then 'make sure there is a pacman
       MapObj = mPacMan 'load a pacman
     Else 'load the given object
       MapObj = Int(Mid(LevLine, Char, 1))
     End If
     Call LoadMapObject(MapObj, Lines, Char) 'load the object into the correct position
    Next Char
  Next Lines
 Close #1 'close the open file
 Call ZOrderObjects 'order the objects
 Exit Sub 'finished
ErrHandler: 'ther was an error
 MsgBox Left$(File, 6) & " Is Missing or Corrupt !!", vbCritical 'display error message
 Dim Result As VbMsgBoxResult
 Result = MsgBox("Do You Want To Create A Replacement Level?", vbYesNo, "Create New Level?") 'ask to create a replacment level
 If Result = vbYes Then
  MsgBox "Please Remember To Save The Level As " & Left$(File, 6)
  ThisDir 'goto  this directory
  Shell "leveledit.exe", vbNormalFocus 'load the editor
 ElseIf Result = vbNo Then
  MsgBox "VB Pacman Will Now Exit", vbOKOnly, "Exiting..." 'exit
 End If
 Unload MainFrm
 End
End Sub
'order the objects
Public Sub ZOrderObjects()
' bottom ones first
 With MainFrm
  OrderIt .Wall
  OrderIt .Food
  OrderIt .Beer
  OrderIt .Cherry
  OrderIt .Berry
  OrderIt .Life
  OrderIt .Protect
  OrderIt .PacMan, True
  OrderIt .InfoLabel, True
  OrderIt .Ghoul
 End With
'tops ones last
End Sub
Public Sub OrderIt(Obj As Object, Optional ObjHasNoArray As Boolean = False)
 If ObjHasNoArray = True Then GoTo NoArray
   For ObjNum = 2 To Obj.Count 'go through each array
     Obj(ObjNum).ZOrder 0 'make it top
   Next ObjNum
 Exit Sub
NoArray:
 Obj.ZOrder 0 'make the object top
End Sub
Public Sub LoadMapObject(MapObj, Lines As Integer, Char As Integer)
Dim NewWall As Integer, NewFloor As Integer, NewFood As Integer     '\
Dim NewGhoul As Integer, NewBeer As Integer, NewCherry As Integer   ' >-- the objects that can be placed on the map
Dim NewLife As Integer, NewProtect As Integer, NewBerry As Integer  '/
  With MainFrm
    Select Case MapObj 'select which object is to be loaded
      '---------------------------------------------------------------------------------------'
      ' The following case subs all have the same format. Any differences will be highlighted '
      '---------------------------------------------------------------------------------------'
      Case Floor 'nothing needs to be loaded
      Case mWall 'load the wall
         NewWall = .Wall.Count + 1 'add a wall to the wall array
         Load .Wall(NewWall) 'load the object array
         WallCount = WallCount + 1 'add a wall to its current count
         .Wall(NewWall).Top = Grid * (Lines - 1) '\--set the wall position
         .Wall(NewWall).Left = Grid * (Char - 1) '^
         .Wall(NewWall).Visible = True
         Call AddObjectToList(MainFrm.WallList, Lines, Char, NewWall) 'add the object to the listbox
      Case mPacMan
         'only one pacman, no need to load another
         .PacMan.Top = Grid * (Lines - 1)
         .PacMan.Left = Grid * (Char - 1)
          PacManPos.Y = .PacMan.Top
          PacManPos.X = .PacMan.Left
          PacManLoaded = True
      Case mFood
         NewFood = .Food.Count + 1
         Load .Food(NewFood)
         FoodCount = FoodCount + 1
         .Food(NewFood).Top = Int((Grid - .Food(NewFood).Width) / 2) + (Grid * (Lines - 1))
         .Food(NewFood).Left = Int((Grid - .Food(NewFood).Height) / 2) + (Grid * (Char - 1))
         .Food(NewFood).ZOrder 0
         .Food(NewFood).Visible = True
         Call AddObjectToList(MainFrm.FoodList, Lines, Char, NewFood)
      Case mGhoul
         Randomize Timer
         NewGhoul = .Ghoul.Count + 1
         Load .Ghoul(NewGhoul)
         .Ghoul(NewGhoul).Top = Grid * (Lines - 1)
         .Ghoul(NewGhoul).Left = Grid * (Char - 1)
         GhoulColour = GhoulColour + 1
         If GhoulColour = 5 Then GhoulColour = 1
         LastDirect(NewGhoul) = Int(Rnd * 4) + 1 'Ghouls need a lastdirection
         NextDirect(NewGhoul) = Int(Rnd * 4) + 1 'and a next direction
         GhoulPos(NewGhoul).X = .Ghoul(NewGhoul).Left
         GhoulPos(NewGhoul).Y = .Ghoul(NewGhoul).Top
         .Ghoul(NewGhoul).Picture = .GhoulPic(GhoulColour) 'there are different colours  of ghouls, load the next colour
         .Ghoul(NewGhoul).Visible = True
      Case mBeer
         NewBeer = .Beer.Count + 1
         Load .Beer(NewBeer)
         .Beer(NewBeer).Top = Int((Grid - .Beer(NewBeer).Width) / 2) + (Grid * (Lines - 1))
         .Beer(NewBeer).Left = Int((Grid - .Beer(NewBeer).Height) / 2) + (Grid * (Char - 1))
         .Beer(NewBeer).Visible = True
         Call AddObjectToList(MainFrm.BeerList, Lines, Char, NewBeer)
      Case mCherry
        NewCherry = .Cherry.Count + 1
        Load .Cherry(NewCherry)
        .Cherry(NewCherry).Top = Int((Grid - .Cherry(NewCherry).Width) / 2) + (Grid * (Lines - 1))
        .Cherry(NewCherry).Left = Int((Grid - .Cherry(NewCherry).Height) / 2) + (Grid * (Char - 1))
        .Cherry(NewCherry).Visible = True
        Call AddObjectToList(MainFrm.CherryList, Lines, Char, NewCherry)
      Case mLife
        NewLife = .Life.Count + 1
        Load .Life(NewLife)
        .Life(NewLife).Top = Int((Grid - .Life(NewLife).Width) / 2) + (Grid * (Lines - 1))
        .Life(NewLife).Left = Int((Grid - .Life(NewLife).Height) / 2) + (Grid * (Char - 1))
        .Life(NewLife).Visible = True
        Call AddObjectToList(MainFrm.LifeList, Lines, Char, NewLife)
      Case mProtect
        NewProtect = .Protect.Count + 1
        Load .Protect(NewProtect)
        .Protect(NewProtect).Top = Int((Grid - .Protect(NewProtect).Width) / 2) + (Grid * (Lines - 1))
        .Protect(NewProtect).Left = Int((Grid - .Protect(NewProtect).Height) / 2) + (Grid * (Char - 1))
        .Protect(NewProtect).Visible = True
        Call AddObjectToList(MainFrm.ProtectList, Lines, Char, NewProtect)
      Case mBerry
        NewBerry = .Berry.Count + 1
        Load .Berry(NewBerry)
        .Berry(NewBerry).Top = Int((Grid - .Berry(NewBerry).Width) / 2) + (Grid * (Lines - 1))
        .Berry(NewBerry).Left = Int((Grid - .Berry(NewBerry).Height) / 2) + (Grid * (Char - 1))
        .Berry(NewBerry).Visible = True
        Call AddObjectToList(MainFrm.BerryList, Lines, Char, NewBerry)
    End Select
  End With
End Sub
Public Sub UpdateObjPos(Lines As Integer, Char As Integer, NewFood As Integer)
 'update the one string encoded position of an object
 TmpStr3 = Trim(Str(NewFood)) 'the type of food ( ie beer, berry , cherry, etc,)
 Lines = Lines - 1 'the y-pos , -1 because there is no 0 line
 Char = Char - 1 'the x-pos
 'the y-position
 If Int(Grid * Lines) < 1000 Then 'the position has 3 digits
   TmpStr1 = "0" & Trim(Str(Int(Grid * Lines))) 'make sure the string has 4 digits
  Else
   TmpStr1 = Trim(Str(Int(Grid * Lines))) 'the string already has 4 digits
 End If
 'the x-position
 If Int(Grid * Char) < 1000 Then 'the position has 3 digits
   TmpStr2 = "0" & Trim(Str(Int(Grid * Char - 1))) 'make sure the string has 4 digits
  Else
   TmpStr2 = Trim(Str(Int(Grid * Char - 1))) 'the string already has 4 digits
 End If
 FinalString = Trim(TmpStr1 & TmpStr2 & TmpStr3) 'the final string is all the 3 tmp string added together
End Sub
'add an objects position to its listbox
Public Sub AddObjectToList(List As ListBox, Lines As Integer, Char As Integer, NewFood As Integer)
 Call UpdateObjPos(Lines, Char, NewFood) 'encode the positions into a string
 List.AddItem FinalString 'add the string to the listbox
 Lines = Lines + 1 'restore original line number
 Char = Char + 1 'restore original char number
End Sub
'check for an onject in the specified direction
Public Function CheckForObject(Direction As Integer, WhichList As ListBox) As Integer
 If UpdateStrObjectPos(Direction, MainFrm.PacMan) = 1 Then GoTo CollectFood 'there is food there
 CheckForObject = 0 'ther is no food there
 Exit Function
CollectFood: 'the food is being eaten , so remove it from the list
  FinalString = Trim(TmpStr1 & TmpStr2) ' encode the string
  For I = 0 To WhichList.ListCount 'go through each entry on in the list
    TmpStr3 = Trim(Left$(WhichList.List(I), 8)) 'get the cutrrent list string
    On Error Resume Next
    If TmpStr3 = FinalString Then 'test for a match, there is a match
       TmpStr3 = Trim(WhichList.List(I))
       CheckForObject = Val(Right(TmpStr3, (Len(TmpStr3) - 8))) 'return the food array number
       WhichList.List(CheckForObject - 2) = "" 'set the value to a null string, as the food has been eaten
    End If
  Next I
End Function
' update the encoded string position on the next direction
Public Function UpdateStrObjectPos(Direction As Integer, Object As Object) As Integer
Dim I As Integer 'used in for..next loops
On Error Resume Next
With MainFrm
If NowDead = True Then Exit Function 'make sure pacman is alive
  Select Case Direction
   Case Is = 1 'Up
    'encode the string. see the sub "UpdateObjPos" to see how this works
    If Int(Object.Top - Grid) < 1000 Then
      TmpStr1 = "0" & Trim(Str(Int(Object.Top - Grid)))
     Else
      TmpStr1 = Trim(Str(Int(Object.Top - Grid)))
    End If
    If Int(Object.Left) < 1000 Then
      TmpStr2 = "0" & Trim(Str(Int(Object.Left - 1)))
     Else
      TmpStr2 = Trim(Str(Int(Object.Left - 1)))
    End If
    UpdateStrObjectPos = 1
   Case Is = 2 'Down
    'encode the string. see the sub "UpdateObjPos" to see how this works
    If Int(Object.Top + Grid) < 1000 Then
      TmpStr1 = "0" & Trim(Str(Int(Object.Top + Grid)))
     Else
      TmpStr1 = Trim(Str(Int(Object.Top + Grid)))
    End If
    If Int(Object.Left) < 1000 Then
      TmpStr2 = "0" & Trim(Str(Int(Object.Left - 1)))
     Else
      TmpStr2 = Trim(Str(Int(Object.Left - 1))) '   Else
    End If
    UpdateStrObjectPos = 1
   Case Is = 3 'left
     'encode the string. see the sub "UpdateObjPos" to see how this works
     If Int(Object.Top) < 1000 Then
       TmpStr1 = "0" & Trim(Str(Int(Object.Top)))
      Else
       TmpStr1 = Trim(Str(Int(Object.Top)))
     End If
     If Int(Object.Left - Grid) < 1000 Then
       TmpStr2 = "0" & Trim(Str(Int(Object.Left - Grid) - 1))
      Else
       TmpStr2 = Trim(Str(Int(Object.Left - Grid) - 1))
     End If
     UpdateStrObjectPos = 1
   Case Is = 4 'Right
     'encode the string. see the sub "UpdateObjPos" to see how this works
     If Int(Object.Top) < 1000 Then
       TmpStr1 = "0" & Trim(Str(Int(Object.Top)))
      Else
       TmpStr1 = Trim(Str(Int(Object.Top)))
     End If
     If Int(Object.Left + Grid) < 1000 Then
       TmpStr2 = "0" & Trim(Str(Int(Object.Left + Grid) - 1))
      Else
       TmpStr2 = Trim(Str(Int(Object.Left + Grid) - 1))
     End If
     UpdateStrObjectPos = 1
  End Select
 End With
End Function
'change the directory
Public Function ThisDir(Optional SubDir As String) As Boolean
On Error GoTo errHand:
 ChDrive App.Path 'goto this drive
 ChDir App.Path & "\" & SubDir 'goto this dir
 ThisDir = True 'dir exsits
 Exit Function
errHand:
ThisDir = False 'dir not there
End Function
'test for a wall
Public Function IsWallThere(Object As Object, Direction As Integer) As Boolean
 Call UpdateStrObjectPos(Direction, Object) '\--encode the string
  FinalString = Trim(TmpStr1 & TmpStr2)     '/-^
  For I = 0 To MainFrm.WallList.ListCount 'go throgh the list of walls
    TmpStr3 = Trim(Left$(MainFrm.WallList.List(I), 8)) 'get the current list string
    If TmpStr3 = FinalString Then 'test if it is there
     IsWallThere = True 'there is a wall there
    End If
  Next I
End Function
'pause the app
Public Sub Pause(PauseTime As Single)
 Dim StartTime As Single
 StartTime = Timer
 Do While Timer < PauseTime + StartTime
  DoEvents
 Loop
End Sub
'unloads all arrays (objects) and clears all lists
Public Sub UnloadArrays()
  On Error Resume Next
 With MainFrm
  UnloadArray .Wall     '\
  UnloadArray .Food     ' \
  UnloadArray .Life     '  \
  UnloadArray .Protect  '   \--unload all objects
  UnloadArray .Ghoul    '   /-^
  UnloadArray .Beer     '  /
  UnloadArray .Berry    ' /
  UnloadArray .Cherry   '/
  
  .BerryList.Clear      '\
  .BeerList.Clear       ' \
  .CherryList.Clear     '  \
  .FoodList.Clear       '   |-- clear lists
  .LifeList.Clear       '  /
  .ProtectList.Clear    ' /
  .WallList.Clear       '/
 End With
End Sub
'unload the array
Public Sub UnloadArray(UnArray)
 On Error Resume Next 'only happen if obj not exsist
 For I = (UnArray.UBound + 5) To 0 Step -1 'go through each array
  Unload UnArray(I) 'unload it
 Next I
End Sub

